EDBFrame = CreateFrame("Frame", "EDBFrame")
local playername=(UnitName("PLAYER"));

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB_CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB_GuildFrameUpdated() end);
			EDBFrame:UnregisterEvent("ADDON_LOADED");
		end
	end
end

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function EDB_CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBSpecText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBSpecText:SetHeight(10);
		EDBSpecText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBSpecButton = CreateFrame("Button", nil, EDBFrame)
		EDBSpecButton:RegisterForClicks("LeftButtonUp", "RightButtonUp");
		EDBSpecButton:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBSpecButton:SetWidth(100)
		EDBSpecButton:SetHeight(10);
		EDBSpecButton:SetScript("OnClick", Elgoh_CycleSpec);
		
		EDBDKPText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("RIGHT");
		EDBDKPText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 0, -15);
		EDBDKPText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -15);
		
		EDBThreshText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBThreshText:SetHeight(10);
		EDBThreshText:SetJustifyH("RIGHT");
		EDBThreshText:SetPoint("TOPLEFT", EDBDKPText, "BOTTOMLEFT", 0, -5);
		EDBThreshText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -35);
		
		if(CanEditOfficerNote()==1) then
			EDBEPGPFrame = CreateFrame("Frame", "EDBEPGPFrame")
			EDBEPGPFrame:SetParent(GuildMemberDetailFrame);
			EDBEPGPFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
			EDBEPGPFrame:SetHeight(55);
			EDBEPGPFrame:SetPoint("TOPLEFT", EDBFrame, "BOTTOMLEFT", 0, 5);
			EDBEPGPFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
			
			EDBAmountBox = CreateFrame("EditBox", nil, EDBEPGPFrame, "InputBoxTemplate")
			EDBAmountBox:SetWidth(60)
			EDBAmountBox:SetHeight(20)
			EDBAmountBox:SetPoint("LEFT", EDBEPGPFrame, "LEFT", 15,0);
			EDBAmountBox:SetAutoFocus(false)
			EDBAmountBox:SetJustifyH("LEFT");
			EDBAmountBox:SetText("0");
			EDBAmountBox:SetScript("OnEnterPressed", function() EDBAmountBox:ClearFocus(); end)
			
			EDBAwardEP = CreateFrame("Button", nil, EDBEPGPFrame, "UIPanelButtonTemplate");
			EDBAwardEP:SetWidth(40);
			EDBAwardEP:SetHeight(40);
			EDBAwardEP:SetText("EP");
			EDBAwardEP:SetPoint("LEFT", EDBAmountBox, "RIGHT", 5,0);
			EDBAwardEP:SetScript("OnClick", function() EDB_GrantEPGP("EP", tonumber(EDBAmountBox:GetText()), EDB.selected, false); end);
			
			EDBAwardGP = CreateFrame("Button", nil, EDBEPGPFrame, "UIPanelButtonTemplate");
			EDBAwardGP:SetWidth(40);
			EDBAwardGP:SetHeight(40);
			EDBAwardGP:SetText("GP");
			EDBAwardGP:SetPoint("LEFT", EDBAwardEP, "RIGHT", 5,0);
			EDBAwardGP:SetScript("OnClick", function() EDB_GrantEPGP("GP", tonumber(EDBAmountBox:GetText()), EDB.selected, false); end)
		end
		--EDB_GrantEPGP(EPGP, amount, who, mass, reason)
		EDB_MakeTooltips();
	end
end

function Elgoh_CycleSpec(self, button)
	if(button=="LeftButton") then
		EDB[EDB.selected]["MS"]=EDB[EDB.selected]["MS"]-1;
		if(EDB[EDB.selected]["MS"]<=0) then EDB[EDB.selected]["MS"]=3; end
	elseif(button=="RightButton") then
		EDB[EDB.selected]["OS"]=EDB[EDB.selected]["OS"]-1;
		if(EDB[EDB.selected]["OS"]<=0) then EDB[EDB.selected]["OS"]=3; end
	end
	EDB_UpdateLines(EDB.selected);
	EDB_ToNote(EDB.selected);
end


function EDB_GuildFrameUpdated(ow)
	local pname= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if((pname == EDB.selected) or ow) then return end
		EDB.selected = pname;
		EDB_Snapshot(UnitName("PLAYER"));
		EDB_Snapshot(pname);
		EDB_UpdateLines(EDB.selected);
	end
end

local Roles={"Tank","Healer","DPS"};
function EDB_UpdateLines(who)
	EDBDKPText:SetText("");
	local MSText="";
	local OSText="";
	local EPGPThreshhold=ElgohSettings["EPGPThreshhold"];
	if(EDB[who]) then
		MSText=Roles[EDB[who]["MS"]];
		OSText=Roles[EDB[who]["OS"]];
		EDBSpecText:SetText(MSText.."/"..OSText);
		--- DKP bit
		if(who~=playername) then
			if(EDB[playername] and EDB[playername]["priority"]~=nil) then
				if(EDB[who]["priority"]) then
					EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
					EDBDKPText:SetTextColor(0.2,1,0.2);
					if((EDB[playername]["earned"]>EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) or (EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]<EPGPThreshhold)) then
						if(EDB[who]["priority"]>EDB[playername]["priority"]) then
							EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
							EDBDKPText:SetTextColor(1,0.2,0.2);
						end
					elseif(EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) then
						EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
						EDBDKPText:SetTextColor(1,0.2,0.2);
					end
				end
			end
		else
			EDBDKPText:SetText("DKP: "..EDB[playername]["priority"]);
			EDBDKPText:SetTextColor(1,1,1);			
		end
		if(EDB[who]["earned"]>EPGPThreshhold) then EDBThreshText:SetTextColor(0.2,1,0.2); EDBThreshText:SetText("Above "..EPGPThreshhold); else EDBThreshText:SetTextColor(1,0.2,0.2); EDBThreshText:SetText("Below "..EPGPThreshhold); end
	end
end

function EDB_LoadValues(who)
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
			if(GL_DKPValues["current_dkp_data"][name:lower()]~=nil) then
				EDB[name]["earned"]=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				EDB[name]["spent"]=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				EDB[name]["priority"]=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
			end
		end
	end
end

function EDB_PasteImport()
-- for line do (for numbers do)
	for word in string.gmatch("Hello Lua user", "%a+") do 
		print(word) 
	end
end

function EDB_ToNote(who)
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);	
		if(who==nil or name==who) then
		if(EDB[who].earned~=0) then
			if(EDB[who].spent~=0) then
				EDB[who].priority=(floor(((EDB[who].earned/EDB[who].spent)*100) + 0.5 )) /100;
			else
				EDB[who].priority=EDB[who].earned;
			end
		end
			local oNote=strjoin(":","$"..EDB[name]["MS"], EDB[name]["OS"], EDB[name]["earned"], EDB[name]["spent"], EDB[name]["priority"].."$");
			GuildRosterSetOfficerNote(i, oNote);
		end
	end
end

function EDB_Snapshot(who)
--EDebug("Snapshotting "..who);
if(CanEditOfficerNote()~=1) then EDebug("Querying Officers..."); QueryOfficer(who); return; end
	for i = 1, GetNumGuildMembers(), 1 do
		local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
		if(name==who) then
			local EDBString=string.match(officernote, "$(.*)%$");
			if(EDBString==nil) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			
			local MS,OS,Earned,Spent,Priority=strsplit(":",EDBString);
			MS=tonumber(MS);
			OS=tonumber(OS);
			Earned=tonumber(Earned);
			Spent=tonumber(Spent);
			Priority=tonumber(Priority);
			
			if(MS~=1 and MS~=2 and MS~=3) then Elgoh_Print("Invalid EPGP string found: Defaulting "..who); Elgoh_Default(who); return; end
			if(Earned==nil or Spent==nil or Priority==nil) then Elgoh_Print("Invalid EPGP string found: Defaulting "..who); Elgoh_Default(who); return; end
			if(Priority~=(floor(((Earned/Spent)*100) + 0.5 ))/100 and Priority~=0 and Priority~=Earned) then 
				Elgoh_Print("Edited EPGP string found (values have been altered): Defaulting "..who); 
				Elgoh_Default(who); 
				SendChatMessage("Warning: EPGP for "..who.." had been externally edited (advise beatings)", "OFFICER");
				return; 
			end
			
			EDB[who]={};
			EDB[who]["MS"]=MS;
			EDB[who]["OS"]=OS;
			EDB[who]["earned"]=Earned;
			EDB[who]["spent"]=Spent;
			EDB[who]["priority"]=Priority;
			return;
		end
	end
end

function QueryOfficer(who)
	ElgohWaitingOnOfficer=true;
	EDBFrame:SetScript("OnUpdate", EDBFrame_OnUpdate);
	EDBFrame.TimeSinceLastUpdate=0;
	SendAddonMessage("elgoh", "!"..who, "GUILD");
end

function EDBFrame_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	

	if(self.TimeSinceLastUpdate>=0.5) then
		if(ElgohWaitingOnOfficer==true) then
			Elgoh_Print("No Officer reply");
		end
		self.TimeSinceLastUpdate = 0;
		ElgohWaitingOnOfficer=false;
		self:SetScript("OnUpdate", nil);
	end
end

function Elgoh_History(who,what,when,why)
	if(#ElgohHistory==nil) then tinsert(ElgohHistory, "Everyone:0:Beginning of Time:S+G"); end
	if(why==nil) then why="Officer Reasons"; end
	--tinsert(ElgohHistory, strjoin(":", who,what,when,why));
	EDebug("Added line "..#ElgohHistory.." to the EPGP History");
end

function Elgoh_PrintHistory()
if(ElgohHistory==nil or ElgohHistory=={}) then Elgoh_Print("No History"); return; end
	Elgoh_Print("Printing local EPGP history");
	for index,value in pairs(ElgohHistory) do
		Elgoh_Print(index..": "..value);
	end
end

function Elgoh_ExportHistory()
if(ElgohHistory==nil or ElgohHistory=={}) then Elgoh_Print("No History"); return; end
ElgohHTML="<center><table>";
	for index,value in pairs(ElgohHistory) do
		who,what,when,why=strsplit(":", value);
		ElgohHTML=ElgohHTML.."<tr><td>"..index..") </td><td>"..who.."</td><td> was given "..what.."</td><td> for "..why..".</td><td> ("..when.." Epoch Time)</td></tr>";
	end
	ElgohHTML=ElgohHTML.."</table>";
	URLFrameEditBox:SetText(ElgohHTML);
	URLFrameEditBox:HighlightText();
	URLFrame:Show();
end

function EDB_GrantEPGP(EPGP, amount, who, mass, reason)
	if(EPGP=="EP") then values="earned"; else values="spent"; end
	if mass then
		for i=1,#who do
			EDB_Snapshot(who[i]);
			EDB[who[i]][values]=EDB[who[i]][values]+amount;
			EDB_ToNote(who[i]);
			Elgoh_History(who,amount,time(),reason);
		end
		local msg=#who.." peoples "..EPGP.." has been changed by "..amount;
		if(reason~=nil) then msg=msg.." for "..reason; end
		SendChatMessage(msg, "OFFICER");
	else
		EDB_Snapshot(who);
		EDB[who][values]=EDB[who][values]+amount;
		EDB_ToNote(who);
		Elgoh_History(who,amount,time(),reason);
		local msg=who.."'s "..EPGP.." has been changed by "..amount;
		if(reason~=nil) then msg=msg.." for "..reason; end
		SendChatMessage(msg, "OFFICER");
		if(EDBDKPText~=nil) then EDB_UpdateLines(EDB.selected); end
	end
end

function Elgoh_Default(who)
	EDB[who]={};
	EDB[who]["MS"]=3;
	EDB[who]["OS"]=3;
	EDB[who]["earned"]=0;
	EDB[who]["spent"]=0;
	EDB[who]["priority"]=0;
	EDB_LoadValues(who);
	EDB_ToNote(who);
end